#COMPILE EXE
#DIM ALL
'#INCLUDE "win32api.inc"
'#INCLUDE "commCtrl.inc"
'#INCLUDE "COMDLG32.INC"            
#INCLUDE "LibrListAPI.inc"
#INCLUDE "LibrList.inc"
#INCLUDE "columnListClass.inc"
#INCLUDE "TPrint.inc"
'#INCLUDE "debug.inc"
#RESOURCE "LibrList.pbr"
$verNo = "2.05"
'GLOBAL dbug AS LONG
                             
FUNCTION PBMAIN
   LOCAL nStyle, numCols, pageWidth, pageHeight AS LONG
   numCols = 6
   DIM wc(1 TO numCols) AS LONG
   DIM tc(1 TO numCols) AS STRING
   DIM tabHandle(1 TO 4)
   mainWidth = 720: mainHeight = 480  '75
   wc(1) = 23: wc(2) = 32: wc(3) = 12: wc(4) = 9: wc(5) = 12: wc(6) = 12  'pct
   tc(1) = "Author": tc(2) = "Title": tc(3) = "Call No": 
   tc(4) = CHR$(2) + "Pub Date": tc(5) = CHR$(2) + "  Ordered": tc(6) = "  Library" 
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW PIXELS, 0, "My Library List", , , mainWidth, mainHeight, nStyle TO hMain

   nStyle = %SS_GRAYRECT + %SS_BLACKFRAME
   CONTROL ADD LINE, hMain, %ID_Toolbar, "", 0, 0, mainWidth - 2, 30, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hMain, %ID_AddBtn, "Add", 2, 2, 60, 25, %WS_TABSTOP OR %WS_GROUP
   CONTROL ADD BUTTON, hMain, %ID_EditBtn, "Edit", 62, 2, 60, 25 
   CONTROL ADD BUTTON, hMain, %ID_ViewBtn, "View", 122, 2, 60, 25
   CONTROL ADD BUTTON, hMain, %ID_PrintBtn, "Print", 200, 2, 60, 25
   CONTROL ADD BUTTON, hMain, %ID_QuitBtn, "&Quit", 260, 2, 60, 25
   CONTROL ADD LABEL, hMain, -1, "Find:", 380, 7, 25, 15
   CONTROL ADD TEXTBOX, hMain, %ID_AuthorTi, "Author/Title", 410, 5, 150, 20
   CONTROL ADD LABEL, hMain, %ID_NotFound, "", 570, 7, 70, 15
   CONTROL SET COLOR hMain, %ID_AuthorTi, %GRAY, -1
   CONTROL SET COLOR hMain, %ID_NotFound, %RED, -1
         
   LET oColList1 = CLASS "cColumnList"
   LET oColList2 = CLASS "cColumnList"
   LET oColList3 = CLASS "cColumnList"
   LET oColList4 = CLASS "cColumnList"
   
   'add tabcontrol
   nStyle = %TCS_SINGLELINE OR %TCS_OWNERDRAWFIXED OR %WS_TABSTOP 'OR %TCS_FIXEDWIDTH 'OR %TCS_FOCUSBUTTONDOWN
   pageWidth = mainWidth - 4: pageHeight = mainHeight - 82
   CONTROL ADD TAB, hMain, %ID_Tab, "", 1, 37, pageWidth, pageHeight, nStyle
   CONTROL SEND hMain, %ID_Tab, %WM_UPDATEUISTATE, MAKLNG(%UIS_CLEAR, %UISF_HIDEFOCUS OR %UISF_HIDEACCEL), 0
   
   'build the first tab page - all books
   TAB INSERT PAGE hMain, %ID_Tab, 1, 0, "  All Books          " CALL TabProc TO hTab
   oColList1.createCtrl(hTab, %ID_All, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(1) = hTab
   
   'build the second tab page - want to read books
   TAB INSERT PAGE hMain, %ID_Tab, 2, 0, " Want to read        " CALL TabProc TO hTab
   oColList2.createCtrl(hTab, %ID_NotRead, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(2) = hTab
   
   'build the third tab page - already read books (current)
   TAB INSERT PAGE hMain, %ID_Tab, 3, 0, " Have read        " CALL TabProc TO hTab
   oColList3.createCtrl(hTab, %ID_HaveRead, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(3) = hTab
   
   'build the fourth tab page - custom book list
   TAB INSERT PAGE hMain, %ID_Tab, 4, 0, " Custom list          " CALL TabProc TO hTab
   tabHandle(4) = hTab 
   nStyle = %CBS_DROPDOWNLIST OR %CBS_SORT OR %WS_VSCROLL OR %WS_TABSTOP OR %WS_GROUP
   CONTROL ADD OPTION, hTab, %ID_ByAuthor, "List by author", 20, 10, 90, 20, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hTab, %ID_ByCatg, "List by category", 20, 30, 90, 20
   CONTROL SET OPTION hTab, %ID_ByAuthor, %ID_ByAuthor, %ID_ByCatg
   CONTROL ADD OPTION, hTab, %ID_AllBooksOpt, "All books", 150, 10, 80, 20, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hTab, %ID_NotReadOpt, "Want to read", 150, 30, 80, 20
   CONTROL ADD OPTION, hTab, %ID_HaveReadOpt, "Have read", 150, 50, 80, 20
   CONTROL SET OPTION hTab, %ID_AllBooksOpt, %ID_AllBooksOpt, %ID_HaveReadOpt
   CONTROL ADD COMBOBOX, hTab, %ID_CustomList, , 270, 20, 200, 300, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hTab, %ID_ClearList, "&Clear", 500, 18, 60, 25
   oColList4.createCtrl(hTab, %ID_Custom, 2, 80, pageWidth, pageHeight - 85, VARPTR(wc(1)), VARPTR(tc(1)), numCols)

   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL bkColor, hBrush, hIcon, hList, curItem, x, y AS LONG
   LOCAL nStyle, flags, i, j, k, m, n, result, hIniFile AS LONG
   LOCAL ti, folder, filter, f, s AS STRING, pt AS POINTAPI
   STATIC helpFile AS ASCIIZ * %MAX_PATH
   STATIC tabPageLast AS LONG

   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         helpFile = CURDIR$ + "\LibrList.chm"
         hIcon = LoadImage(GetModuleHandle(BYVAL %NULL), "LibrList", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, %ICON_BIG, hIcon
         addMenu
         addStatusbar
         dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS) 
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents\"
         dataFolder = dataFolder + "\cgdSoftware\LibrList"
         IF ISFILE(dataFolder) = 0 THEN createFolder dataFolder
         IF ISFILE(dataFolder) THEN 'define iniFile
            iniFile = dataFolder + "\LibrList.ini"
         END IF
         listID = %ID_All
         bkColor = RGB(200,200,255)
         hBrush=CreateSolidBrush(bkColor)
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), 0, GetCurrentThreadID)
         oColList = oColList1
         tabPageLast = 1
         IF ISFILE(iniFile) THEN openIniFile: openThisFile
      CASE %WM_CTLCOLORDLG 
         FUNCTION = hBrush
      CASE %WM_DRAWITEM 'draw tab item text in different color on select
         IF CB.WPARAM = %ID_Tab THEN colorTab CBHNDL, CBWPARAM, CBLPARAM
      CASE %WM_NOTIFY
         IF CB.WPARAM = %ID_Tab THEN
            TAB GET SELECT CBHNDL, %ID_Tab TO tabPage
            IF tabPage = tabPageLast THEN EXIT FUNCTION
            tabPageLast = tabPage
            SELECT CASE tabPage
            CASE 1: oColList = oColList1: listID = %ID_All 
            CASE 2: oColList = oColList2: listID = %ID_NotRead
            CASE 3: oColList = oColList3: listID = %ID_HaveRead
            CASE 4: oColList = oColList4: listID = %ID_Custom
            END SELECT
            hTab = tabHandle(tabPage): listBooks
            IF tabPage = 4 THEN
               fillComboList hTab, %ID_CustomList, numAuthors, VARPTR(authors(1))
            END IF   
         END IF 
      CASE %WM_COMMAND
         IF CB.CTLMSG = %BN_CLICKED THEN
            IF CB.CTL = %IDM_FileOpen THEN
               ti = "Open File": folder = dataFolder
               flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               filter = CHR$("LibrList", 0, "*.lib", 0, "All Files", 0, "*.*", 0)
               DISPLAY OPENFILE CB.HNDL,,, ti, folder, filter, "", "lbl", flags TO f
               IF LEN(f) THEN
                  IF fileChanged THEN
                    s = "Current file has changed..." + $CRLF + "Save it before opening the new file?"
                    n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                    IF n = %IDYES THEN saveThisFile
                  END IF
                  thisFile = f: openThisFile: listBooks 
                  IF numBooks = 0 THEN initializeBooks
               END IF
            ELSEIF CB.CTL = %IDM_FileSave THEN
               s = "Save this file now?"
               n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
               IF n = %IDYES THEN saveThisFile: listBooks
            ELSEIF CB.CTL = %IDM_FileSaveAs THEN
               saveAsFile: showStatus
            ELSEIF CB.CTL = %IDM_FilePrint OR CB.CTL = %ID_PrintBtn THEN
               printBooks
            ELSEIF CB.CTL = %IDM_FileExit OR CB.CTL = %ID_QuitBtn THEN
               DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            ELSEIF CB.CTL = %IDM_AddBook OR CB.CTL = %ID_AddBtn THEN
               gAuthor = 0:
               k = oColList.getHiLite
               IF k THEN
                  n = oColList.getExtra(k)
                  gAuthor = books(n).author
               END IF
               addBook
            ELSEIF CB.CTL = %IDM_EditBook OR CB.CTL = %ID_EditBtn THEN
               k = oColList.getHiLite
               IF k THEN addBook k
            ELSEIF CB.CTL = %IDM_ViewBook OR CB.CTL = %ID_ViewBtn THEN
               k = oColList.getHiLite
               IF k THEN addBook -k
            ELSEIF CB.CTL = %IDM_DelBook THEN
               m = oColList.getHiLite
               IF m THEN
                  n = oColList.getExtra(m)
                  s = "Are you sure you want to delete this book?" + $CRLF + $CRLF + _ 
                      titles(n) + $CRLF + "By " + authors(books(n).author)
                  k = MSGBOX(s, %MB_YESNO OR %MB_ICONWARNING, "Book Removal")
                  IF k = %IDYES THEN
                     BIT SET books(n).flags, 4 
                     listBooks m: fileChanged = 1
                  END IF 
               END IF
            ELSEIF CB.CTL = %IDM_PrnBook THEN
               k = oColList.getHiLite
               IF k THEN printBook k   
            ELSEIF CB.CTL >= %IDM_ComboAuthors AND CB.CTL <= %IDM_ComboCatgs THEN
               dropDnEdit CB.CTL
            ELSEIF CB.CTL >= %IDM_AllBooks AND CB.CTL <= %IDM_CustomList THEN
               tabPage = CB.CTL - %IDM_AllBooks + 1
               SELECT CASE tabPage
               CASE 1: oColList = oColList1: listID = %ID_All 
               CASE 2: oColList = oColList2: listID = %ID_NotRead
               CASE 3: oColList = oColList3: listID = %ID_HaveRead
               CASE 4: oColList = oColList4: listID = %ID_Custom
               END SELECT
               hTab = tabHandle(tabPage)
               SetFocus GetDlgItem(CB.HNDL, %ID_Tab)
               TAB SELECT CB.HNDL, %ID_Tab, tabPage
               numToShow = oColList.getNumItems: listBooks
            ELSEIF CB.CTL = %IDM_HelpContent THEN
               HtmlHelp CBHNDL, helpFile, 0, 0
            ELSEIF CB.CTL = %IDM_HelpAbout THEN
               showAbout
            END IF
            FOR n = %ID_AddBtn TO %ID_QuitBtn 'clear visible focus of buttons pressed
               CONTROL SEND CBHNDL, n, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            NEXT n
         ELSEIF CB.CTLMSG = %EN_SETFOCUS AND CB.CTL = %ID_AuthorTi THEN
            CONTROL SET TEXT CB.HNDL, CB.CTL, ""
            CONTROL SET COLOR CB.HNDL, CB.CTL, %BLACK, -1
            srchAuthorTi = 1
         ELSEIF CB.CTLMSG = %EN_KILLFOCUS AND CB.CTL = %ID_AuthorTi THEN
            IF srchAuthorTi THEN
               srchAuthorTi = 0
               CONTROL SET TEXT hMain, %ID_AuthorTi, "Author/Title"
               CONTROL SET COLOR hMain, %ID_AuthorTi, %GRAY, -1
            END IF
         ELSEIF CB.CTLMSG = %EN_CHANGE AND CB.CTL = %ID_AuthorTi THEN 
            searchAuthorTi   
         END IF
      CASE %WM_LBUTTONDOWN, %WM_NCLBUTTONDOWN
         IF srchAuthorTi THEN
            srchAuthorTi = 0
            CONTROL SET TEXT hMain, %ID_AuthorTi, "Author/Title"
            CONTROL SET COLOR hMain, %ID_AuthorTi, %GRAY, -1
            CONTROL SET FOCUS hTab, listID
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            IF fileChanged THEN 'prompt to save
                 s = "This file has changed... save it before quiting?"
                 n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONQUESTION, "Quit Program")
                 IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
                 IF n = %IDYES THEN saveThisFile
            END IF
         END IF
      CASE %WM_CONTEXTMENU 'right-click 
         pt.x = LOWRD(CBLPARAM): pt.y = HIWRD(CBLPARAM)
         ScreenToClient CBWPARAM, pt
         oColList.getListboxPos(x, y)
         pt.x = pt.x - x: pt.y = pt.y - y
         hList = GetDlgItem(hTab, listID)
         IF pt.y < 0 OR CBWPARAM <> hTab THEN EXIT FUNCTION
         'debug CBWPARAM, hList, hTab, CB.HNDL, pt.y, y
         curItem = LOWRD(SendMessage(hList, %LB_ITEMFROMPOINT, 0, MAKLNG(pt.x, pt.y))) + 1
         oColList.setHiLite(curItem): showStatus
         TrackPopupMenu hMouseMenu, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, _
                     LOWRD(CBLPARAM), HIWRD(CBLPARAM), 0, CBHNDL, BYVAL %NULL
      CASE %WM_DESTROY
         DeleteObject hBrush
         UnhookWindowsHookEx ghKbdHook
   END SELECT   
END FUNCTION

CALLBACK FUNCTION TabProc()
   LOCAL i, j, k, n, nAuthor, nCatg AS LONG
   LOCAL sAuthor, sCatg AS STRING
   SELECT CASE CB.MSG
   CASE %WM_COMMAND
      IF CB.CTL = listID AND CB.CTLMSG = %LBN_SELCHANGE THEN
         showStatus
      ELSEIF CB.CTL = listID AND CB.CTLMSG = %LBN_DBLCLK THEN
         IF numBooks THEN 'show book data 
            k = oColList.getHiLite: IF k THEN addBook -k
         END IF
      ELSEIF (CB.CTL = %ID_ByAuthor OR CB.CTL = %ID_ByCatg) AND CB.CTLMSG = %BN_CLICKED THEN
         CONTROL GET CHECK hTab, %ID_ByAuthor TO n
         IF n THEN
            fillComboList hTab, %ID_CustomList, numAuthors, VARPTR(authors(1))
         ELSE
            fillComboList hTab, %ID_CustomList, numCatgs, VARPTR(Catgs(1))
         END IF
      ELSEIF CB.CTL = %ID_CustomList AND CB.CTLMSG = %CBN_DROPDOWN THEN
         DIALOG SEND CB.HNDL, %WM_COMMAND, %ID_ByAuthor, 0
      ELSEIF (CB.CTL >= %ID_AllBooksOpt AND CB.CTL <= %ID_HaveReadOpt AND CB.CTLMSG = %BN_CLICKED) OR _
             (CB.CTL = %ID_CustomList AND CB.CTLMSG = %CBN_SELCHANGE) THEN 
         CONTROL GET CHECK hTab, %ID_ByAuthor TO n
         IF n THEN
            COMBOBOX GET SELECT CB.HNDL, %ID_CustomList TO k
            COMBOBOX GET USER CB.HNDL, %ID_CustomList, k TO nAuthor
         ELSE    
            COMBOBOX GET SELECT CB.HNDL, %ID_CustomList TO k
            COMBOBOX GET USER CB.HNDL, %ID_CustomList, k TO nCatg
         END IF
         FOR i = %ID_AllBooksOpt TO %ID_HaveReadOpt
            CONTROL GET CHECK hTab, i TO k: IF k THEN k = i - %ID_AllBooksOpt: EXIT FOR
         NEXT i
         FOR i = 1 TO numBooks
            j = bookNo(i): BIT RESET books(j).flags, 3
            n = BIT(books(j).flags, 1) + 2 * BIT(books(j).flags, 2)
            IF nAuthor AND books(j).author = nAuthor AND (k = 0 OR k = n) THEN BIT SET books(j).flags, 3
            IF nCatg AND CLNG(books(j).catg) = nCatg AND (k = 0 OR k = n) THEN BIT SET books(j).flags, 3
         NEXT i
         oColList = oColList4: listBooks
      ELSEIF CB.CTL = %ID_ClearList AND CB.CTLMSG = %BN_CLICKED THEN 'create custom list
         COMBOBOX UNSELECT CB.HNDL, %ID_CustomList
         FOR i = 1 TO numBooks
            j = bookNo(i)
            BIT RESET books(j).flags, 3
         NEXT i
         oColList = oColList4: listBooks
      END IF
   END SELECT
END FUNCTION

SUB addMenu()
   LOCAL hMenu, hFileMenu, hEditMenu, hViewMenu, hHelpMenu, hMaintMenu AS LONG
   MENU NEW BAR TO hMenu
   'declare menu popUps
   MENU NEW POPUP TO hFileMenu
   MENU NEW POPUP TO hEditMenu
   MENU NEW POPUP TO hViewMenu
   MENU NEW POPUP TO hHelpMenu
   MENU NEW POPUP TO hMaintMenu
   'fill out top menus
   MENU ADD POPUP, hMenu, "&File", hFileMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&View", hViewMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu,%MF_ENABLED
   'fill out drop down menus
   MENU ADD STRING, hFileMenu, "&Open", %IDM_FileOpen,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %IDM_FileSave,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %IDM_FileSaveAs,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Print", %IDM_FilePrint,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit", %IDM_FileExit,%MF_ENABLED
   
   MENU ADD STRING, hEditMenu, "&Add book", %IDM_AddBook, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Edit book", %IDM_EditBook, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Delete book", %IDM_DelBook, %MF_ENABLED
   MENU ADD POPUP, hEditMenu, "List &Maintenance", hMaintMenu, %MF_ENABLED
      MENU ADD STRING, hMaintMenu, "&Authors", %IDM_ComboAuthors, %MF_ENABLED
      MENU ADD STRING, hMaintMenu, "&Call Nos", %IDM_ComboCallNos, %MF_ENABLED
      MENU ADD STRING, hMaintMenu, "&Publishers", %IDM_ComboPubs, %MF_ENABLED
      MENU ADD STRING, hMaintMenu, "&Libraries", %IDM_ComboLibrs, %MF_ENABLED
      MENU ADD STRING, hMaintMenu, "&Categories", %IDM_ComboCatgs, %MF_ENABLED

   MENU ADD STRING, hViewMenu, "&All books", %IDM_AllBooks, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Want To Read", %IDM_WantToRead, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Have read", %IDM_ReadCurrent, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Custom List", %IDM_CustomList, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "-", 0, 0
   MENU ADD STRING, hViewMenu, "&Book data", %IDM_ViewBook, %MF_ENABLED
   
   MENU ADD STRING, hHelpMenu, "&Contents", %IDM_HelpContent, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %IDM_HelpAbout, %MF_ENABLED
   
   'put menu system on window
   MENU ATTACH hMenu, hMain
   
   'floating menus
   MENU NEW POPUP TO hMouseMenu
   MENU ADD STRING, hMouseMenu, "View Book", %IDM_ViewBook, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Edit Book", %IDM_EditBook, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Delete Book", %IDM_DelBook, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Print Book", %IDM_PrnBook, %MF_ENABLED
END SUB

SUB addStatusbar()
   LOCAL w1, w2, w3 AS LONG
   CONTROL ADD STATUSBAR, hMain, %ID_Status, "", 0, 0, 0, 0
   w1 = .50 * mainWidth: w2 = .35 * mainWidth: w3 = mainWidth - (w1 + w2)
   STATUSBAR SET PARTS hMain, %ID_Status, w1, w2, w3
   'showStatus
END SUB

SUB colorTab(hDlg AS LONG, wParm AS LONG, lParm AS LONG)
   LOCAL nColor, hBrush AS LONG
   LOCAL lDISPtr AS DRAWITEMSTRUCT PTR
   LOCAL ti AS TC_ITEM, zCap AS ASCIIZ * 50

   lDisPtr = lparm
   nColor = RGB(220, 230&, 240&)
   hBrush = CreateSolidBrush(nColor)
   SelectObject @lDisptr.hDc, hBrush
   
   @lDisptr.rcItem.nTop = @lDisptr.rcItem.nTop + 3
   IF @lDisPtr.ItemState = %ODS_SELECTED THEN
      SetTextColor @lDisPtr.hDc, %BLUE
      SetBkColor @lDisPtr.hDc, nColor
      FillRect @lDisptr.hDc, @lDisptr.rcItem, hBrush
   ELSE
      SetTextColor @lDisPtr.hDc, %BLACK
      SetBkColor @lDisPtr.hDc, GetSysColor(%COLOR_3DFACE)
      FillRect @lDisptr.hDc, @lDisptr.rcItem, GetSysColorBrush(%COLOR_3DFACE)
   END IF

   ti.mask = %TCIF_TEXT
   ti.pszText = VARPTR(zCap)
   ti.cchTextMax = SIZEOF(zCap)
   CALL TabCtrl_GetItem(GetDlgItem(hDlg, wParm), @lDisptr.itemID, ti)
   DrawText @lDisptr.hDc, zCap, LEN(zCap), @lDisptr.rcItem, %DT_SINGLELINE OR %DT_CENTER
   DeleteObject hBrush
END SUB

SUB addBook(OPT BYVAL n AS LONG)
   LOCAL nStyle, kStyle, wi, ht AS LONG 
   wi = 500: ht = 400: nStyle = %WS_SYSMENU 
   DIALOG NEW PIXELS, hMain, "Add Book to List", , , wi, ht, nStyle TO hAddBook
   nStyle = %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Author:", 5, 15, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Title:", 5, 45, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Call No:", 5, 75, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Order Date (m/d/y):", 240, 75, 98, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Publisher:", 5, 105, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Pub Date (year):", 240, 105, 98, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Library:", 5, 135, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Category:", 5, 165, 58, 16, %SS_RIGHT
   CONTROL ADD LABEL, hAddBook, -1, "Source/Comments:", 5, 205, 100, 16, %SS_RIGHT
   nStyle = %CBS_DROPDOWN OR %CBS_SORT OR %WS_VSCROLL OR %WS_TABSTOP
   kStyle = %WS_BORDER OR %WS_TABSTOP
   IF n < 0 THEN 
      nStyle = nStyle OR %WS_DISABLED
      kStyle = kStyle OR %WS_DISABLED
   END IF
   CONTROL ADD COMBOBOX, hAddBook, %ID_Author, , 65, 15, 250, 300, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAddBook, %ID_Title, "", 65, 44, 335, 23, kStyle, %WS_EX_CLIENTEDGE              
   CONTROL ADD COMBOBOX, hAddBook, %ID_CallNo, , 65, 75, 150, 100, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAddBook, %ID_Ordered, "", 340, 75, 100, 20, kStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD COMBOBOX, hAddBook, %ID_Publisher, , 65, 105, 150, 80, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAddBook, %ID_PubDate, "", 340, 105, 100, 20, kStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD COMBOBOX, hAddBook, %ID_Library, , 65, 135, 150, 80, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD COMBOBOX, hAddBook, %ID_Category, , 65, 165, 150, 200, nStyle, %WS_EX_CLIENTEDGE
   nStyle = %WS_TABSTOP
   IF n < 0 THEN nStyle = nStyle OR %WS_DISABLED 
   CONTROL ADD OPTION, hAddBook, %ID_NotReadOpt, "Want to read", 320, 145, 120, 16, nStyle
   CONTROL ADD OPTION, hAddBook, %ID_HaveReadOpt, "Have read", 320, 165, 125, 16, nStyle
   CONTROL SET OPTION hAddBook, %ID_NotReadOpt, %ID_NotReadOpt, %ID_HaveReadOpt
   kStyle = %ES_MULTILINE OR %WS_VSCROLL OR %ES_WANTRETURN OR %WS_TABSTOP
   IF n < 0 THEN kStyle = kStyle OR %WS_DISABLED
   CONTROL ADD TEXTBOX, hAddBook, %ID_Comment, "", 10, 225, 480, 110, kStyle, %WS_EX_CLIENTEDGE
   nStyle = %WS_TABSTOP OR %BS_DEFAULT: IF n < 0 THEN nStyle = %WS_DISABLED
   CONTROL ADD BUTTON, hAddBook, %IDOK, "&Save", 300, 350, 75, 30, nStyle
   CONTROL ADD BUTTON, hAddBook, %IDCANCEL, "&Cancel", 380, 350, 75, 30
   DIALOG SET USER hAddBook, 1, n
   DIALOG SHOW MODAL hAddBook CALL addBookProc
   n = oColList.getListID
   CONTROL SET FOCUS hTab, n
END SUB 

CALLBACK FUNCTION addBookProc()
   LOCAL i, k, n, hAccl, viewOnly, mo, yr AS LONG
   LOCAL s, ss, msg, sAuthor, sTitle, sComment AS STRING
   LOCAL book AS bookType
   STATIC hiLite, index AS LONG, dateOrdered AS STRING
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         DIALOG GET USER CBHNDL, 1 TO hiLite
         IF hiLite < 0 THEN
            viewOnly = 1: hiLite = ABS(hiLite)
         ELSE 'fill the comboboxes
            fillComboList hAddBook, %ID_Author, numAuthors, VARPTR(authors(1))   
            fillComboList hAddBook, %ID_CallNo, numCallNos, VARPTR(callNos(1))
            fillComboList hAddBook, %ID_Publisher, numPubs, VARPTR(pubs(1))
            fillComboList hAddBook, %ID_Library, numLibrs, VARPTR(librs(1))
            fillComboList hAddBook, %ID_Category, numCatgs, VARPTR(Catgs(1))
         END IF 
         index = hiLite
         IF hiLite THEN index = oColList.getExtra(hiLite)
         IF index THEN 'edit book data
            CONTROL SET TEXT CBHNDL, %ID_Author, authors(books(index).author)
            CONTROL SET TEXT CBHNDL, %ID_Title, titles(index)
            CONTROL SET TEXT CBHNDL, %ID_Comment, comments(index)
            n = books(index).callNo
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_CallNo, callNos(n)
            n = books(index).Ordered
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_Ordered, expandDate(CWRD(n))
            n = books(index).PubDate
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_PubDate, TRIM$(STR$(n))
            n = books(index).publisher           
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_Publisher, pubs(n)
            n = books(index).library
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_Library, librs(n)
            n = books(index).catg
            IF n THEN CONTROL SET TEXT CBHNDL, %ID_Category, catgs(n)
            IF BIT(books(index).flags, 2) THEN n = 1 ELSE n = 0
            CONTROL SET OPTION CB.HNDL, %ID_NotReadOpt + n, %ID_NotReadOpt, %ID_HaveReadOpt 
            IF viewOnly THEN 
               DIALOG SET TEXT CB.HNDL, "View Book Data": EXIT FUNCTION 
            ELSEIF index THEN
               DIALOG SET TEXT CB.HNDL, "Edit Book Data"
            END IF
         ELSEIF gAuthor THEN 
            CONTROL SET TEXT CBHNDL, %ID_Author, authors(gAuthor)   
         END IF
         CONTROL SET FOCUS CB.HNDL, %ID_Author: editAuthor = 1
      CASE %WM_COMMAND
         IF CB.CTL = %ID_Author THEN
            IF CB.CTLMSG = %CBN_SETFOCUS THEN
               editAuthor = 1
            ELSEIF CB.CTLMSG = %CBN_KILLFOCUS THEN
               editAuthor = 0
            ELSEIF index = 0 AND CB.CTLMSG = %CBN_EDITCHANGE THEN
               CONTROL GET TEXT CB.HNDL, CB.CTL TO s
               COMBOBOX FIND CB.HNDL, CB.CTL, 1, s TO n
               IF n THEN 
                  COMBOBOX GET TEXT CB.HNDL, CB.CTL, n TO ss
                  CONTROL SET TEXT CB.HNDL, CB.CTL, ss
                  CONTROL SEND CB.HNDL, CB.CTL, %CB_SETEDITSEL, 0, MAKDWD(LEN(s), -1)
               END IF
            END IF
         ELSEIF CB.CTL = %ID_notReadOpt AND CB.CTLMSG = %BN_CLICKED THEN
            CONTROL SET TEXT CB.HNDL, %ID_Ordered, dateOrdered
         ELSEIF CB.CTL = %ID_HaveReadOpt AND CB.CTLMSG = %BN_CLICKED THEN
            CONTROL GET TEXT CB.HNDL, %ID_Ordered TO dateOrdered
            CONTROL SET TEXT CB.HNDL, %ID_Ordered, ""
         ELSEIF (CB.CTL = %ID_CallNo OR CB.CTL = %ID_Library OR _ 
                 CB.CTL = %ID_Publisher OR CB.CTL = %ID_Category) AND CB.CTLMSG = %CBN_EDITCHANGE THEN
            CONTROL GET TEXT CB.HNDL, CB.CTL TO s
            COMBOBOX FIND CB.HNDL, CB.CTL, 1, s TO n
            IF n THEN 
               COMBOBOX GET TEXT CB.HNDL, CB.CTL, n TO ss
               CONTROL SET TEXT CB.HNDL, CB.CTL, ss
               CONTROL SEND CB.HNDL, CB.CTL, %CB_SETEDITSEL, 0, MAKDWD(LEN(s), -1)
            END IF
         ELSEIF CB.CTL = %IDOK THEN 'save book
            'update authors if new one specified ------------------------------------------------
            CONTROL GET TEXT CB.HNDL, %ID_Author TO s: s = TRIM$(s)
            IF index THEN sAuthor = s ELSE sAuthor = processName(s)
            IF LEN(sAuthor) = 0 THEN
               MSGBOX "Must specify author", %MB_OK OR %MB_ICONERROR, "Add Book Error"
               CONTROL SET FOCUS CB.HNDL, %ID_Author: EXIT FUNCTION
            END IF
            COMBOBOX FIND EXACT CB.HNDL, %ID_Author, 1, sAuthor TO n
                                               
            'IF n = 0 OR index > 0 THEN
            IF n = 0 THEN 'new author  
               INCR numAuthors
               REDIM PRESERVE authors(1 TO numAuthors)
               COMBOBOX ADD CB.HNDL, %ID_Author, sAuthor
               COMBOBOX FIND EXACT CB.HNDL, %ID_Author, 1, sAuthor TO n
               COMBOBOX SET USER CB.HNDL, %ID_Author, n, numAuthors
               authors(numAuthors) = sAuthor: book.author = numAuthors 
            ELSE
               COMBOBOX GET USER CB.HNDL, %ID_Author, n TO n
               book.author = n
            END IF 
            
            book.callNo = updateComboList(%ID_CallNo, callNos(), numCallNos)
            book.publisher = updateComboList(%ID_Publisher, pubs(), numPubs)
            book.library = updateComboList(%ID_Library, librs(), numLibrs)
            book.catg = updateComboList(%ID_Category, catgs(), numCatgs)
            
            CONTROL GET TEXT CB.HNDL, %ID_Ordered TO s: s = TRIM$(s)
            book.ordered = compressDate(s)
            CONTROL GET TEXT CB.HNDL, %ID_PubDate TO s: s = TRIM$(s)
            book.pubDate = VAL(s)
            CONTROL GET TEXT CB.HNDL, %ID_Title TO sTitle
            sTitle = processTitle(sTitle)
            CONTROL GET TEXT CB.HNDL, %ID_Comment TO sComment
            CONTROL GET CHECK CB.HNDL, %ID_HaveReadOpt TO n
            BIT SET book.flags, n + 1
            BIT SET book.flags, 5 
               
            INCR numBooks
            REDIM PRESERVE bookNo(1 TO numBooks)
            REDIM PRESERVE books(1 TO numBooks)
            REDIM PRESERVE titles(1 TO numBooks) 
            REDIM PRESERVE comments(1 TO numBooks)
            n = insertBookNo(sAuthor, sTitle) 
            
            'delete edited book before adding change 
            IF index THEN BIT SET books(index).flags, 4
            
            ARRAY INSERT bookNo(n), numBooks
            books(numBooks) = book
            titles(numBooks) = sTitle
            comments(numBooks) = sComment
            
            fileChanged = 1: DIALOG END CB.HNDL 
            TAB SELECT hMain, %ID_Tab, 1: tabPage = 1
            oColList = oColList1: listID = %ID_All
            listBooks n, n - 9
            
         ELSEIF CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
         END IF
   END SELECT   
END FUNCTION

SUB fillComboList(hDlg AS LONG, ctrlID AS LONG, numList AS LONG, listPtr AS DWORD)
   'fill combobox dropdown list
   LOCAL i, n AS LONG
   IF numList = 0 THEN EXIT SUB
   DIM list(1 TO numList) AS STRING AT listPtr
   COMBOBOX RESET hDlg, ctrlID
   FOR i = 1 TO numList
      COMBOBOX ADD hDlg, ctrlID, list(i)
      COMBOBOX FIND EXACT hDlg, ctrlID, 1, list(i) TO n
      COMBOBOX SET USER hDlg, ctrlID, n, i
   NEXT i
END SUB

FUNCTION updateComboList(ctrlID AS LONG, list() AS STRING, numList AS LONG) AS LONG
   'update combobox list if new item is specified and return item number
   LOCAL n AS LONG
   LOCAL s AS STRING
   CONTROL GET TEXT hAddBook, ctrlID TO s: s = TRIM$(s)
   IF LEN(s) THEN
      COMBOBOX FIND EXACT hAddBook, ctrlID, 1, s TO n
      IF n = 0 THEN  'new item - not found in list()
         INCR numList: REDIM PRESERVE list(1 TO numList)
         COMBOBOX ADD hAddBook, ctrlID, s
         COMBOBOX FIND EXACT hAddBook, ctrlID, 1, s TO n
         COMBOBOX SET USER hAddBook, ctrlID, n, numList
         list(numList) = s: FUNCTION = numList 
      ELSE 'item found in list()
         COMBOBOX GET USER hAddBook, ctrlID, n TO n 
         FUNCTION = n
      END IF
   END IF
END FUNCTION

SUB dropDnEdit(ctrlID AS LONG)
   LOCAL nStyle, hDropDn, w, wi, ht, n AS LONG
   LOCAL s, ti AS STRING
   ht = 200: nStyle = %WS_SYSMENU
   n = ctrlID - %IDM_ComboAuthors + 1
   IF n = 1 THEN w = 250: wi = 400 ELSE w = 150: wi = 300 
   s = CHOOSE$(n, "Authors", "Call Numbers", "Publishers", "Libraries", "Categories")
   ti = "Drop Down List Maintenance - " + s
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU TO hDropDn 
   CONTROL ADD OPTION, hDropDn, %ID_DropDnAdd, "Add", 20, 20, 60, 15, %WS_GROUP OR %WS_TABSTOP 
   CONTROL ADD OPTION, hDropDn, %ID_DropDnChg, "Change", 20, 40, 60, 15
   CONTROL ADD OPTION, hDropDn, %ID_DropDnDel, "Remove", 20, 60, 60, 15
   nStyle = %WS_GROUP OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DROPDOWNLIST OR %CBS_SORT
   CONTROL ADD COMBOBOX, hDropDn, %ID_DropDnCombo, , 120, 20, w, 250, nStyle
   CONTROL ADD TEXTBOX, hDropDn, %ID_DropDnEdit, "", 120, 60, w, 20 
   CONTROL ADD BUTTON, hDropDn, %IDOK, "&Ok", wi - 180, 140, 70, 30
   CONTROL ADD BUTTON, hDropDn, %IDCANCEL, "&Cancel", wi - 105, 140, 70, 30
   DIALOG SET USER hDropDn, 1, ctrlID
   DIALOG SHOW MODAL hDropDn CALL dropDnEditProc
END SUB

CALLBACK FUNCTION dropDnEditProc()
   LOCAL i, j, k, m, n, numDups AS LONG
   LOCAL s, ss, msg AS STRING
   STATIC ctrlID, nOpt AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         DIALOG GET USER CBHNDL, 1 TO ctrlID
         IF ctrlID = %IDM_ComboAuthors THEN
            fillComboList CB.HNDL, %ID_DropDnCombo, numAuthors, VARPTR(authors(1))
         ELSEIF ctrlID = %IDM_ComboCallNos THEN    
            fillComboList CB.HNDL, %ID_DropDnCombo, numCallNos, VARPTR(callNos(1))
         ELSEIF ctrlID = %IDM_ComboPubs THEN   
            fillComboList CB.HNDL, %ID_DropDnCombo, numPubs, VARPTR(pubs(1))
         ELSEIF ctrlID = %IDM_ComboLibrs THEN
            fillComboList CB.HNDL, %ID_DropDnCombo, numLibrs, VARPTR(librs(1))
         ELSEIF ctrlID = %IDM_ComboCatgs THEN   
            fillComboList CB.HNDL, %ID_DropDnCombo, numCatgs, VARPTR(Catgs(1))
         END IF
         CONTROL SET OPTION CB.HNDL, %ID_DropDnAdd, %ID_DropDnAdd, %ID_DropDnDel
         nOpt = 1
         CONTROL DISABLE CB.HNDL, %ID_DropDnCombo
         CONTROL SET FOCUS CB.HNDL, %ID_DropDnEdit
      CASE %WM_COMMAND
         IF CB.CTL >= %ID_DropDnAdd AND CB.CTL <= %ID_DropDnDel THEN
            CONTROL SET TEXT CB.HNDL, %ID_DropDnCombo, ""
            CONTROL SET TEXT CB.HNDL, %ID_DropDnEdit, ""
            CONTROL DISABLE CB.HNDL, %ID_DropDnCombo
            CONTROL DISABLE CB.HNDL, %ID_DropDnEdit
            IF CB.CTL = %ID_DropDnAdd THEN
               nOpt = 1
               CONTROL ENABLE CB.HNDL, %ID_DropDnEdit
               CONTROL SET FOCUS CB.HNDL, %ID_DropDnEdit
            ELSEIF CB.CTL = %ID_DropDnChg THEN
               nOpt = 2
               CONTROL ENABLE CB.HNDL, %ID_DropDnEdit
               CONTROL ENABLE CB.HNDL, %ID_DropDnCombo
               CONTROL SET FOCUS CB.HNDL, %ID_DropDnCombo
            ELSEIF CB.CTL = %ID_DropDnDel THEN
               nOpt = 3
               CONTROL ENABLE CB.HNDL, %ID_DropDnCombo   
               CONTROL SET FOCUS CB.HNDL, %ID_DropDnCombo 
            END IF   
         ELSEIF CB.CTL = %ID_DropDnCombo AND CB.CTLMSG = %CBN_CLOSEUP THEN
            COMBOBOX GET SELECT CB.HNDL, %ID_DropDnCombo TO n
            COMBOBOX GET TEXT CB.HNDL, %ID_DropDnCombo, n TO s
            CONTROL SET TEXT CB.HNDL, %ID_DropDnEdit, s
            CONTROL SEND CB.HNDL, %ID_DropDnEdit, %EM_SETSEL, 0, -1
            CONTROL SET FOCUS CB.HNDL, %ID_DropDnEdit   
         ELSEIF CB.CTL = %IDOK THEN
            IF nOpt = 1 THEN 'add drop down list item
               CONTROL GET TEXT CB.HNDL, %ID_DropDnEdit TO s
               IF ctrlID = %IDM_ComboAuthors THEN
                  INCR numAuthors: authors(numAuthors) = s
               ELSEIF ctrlID = %IDM_ComboCallNos THEN    
                  INCR numCallNos: callNos(numCallNos) = s
               ELSEIF ctrlID = %IDM_ComboPubs THEN   
                  INCR numPubs: pubs(numPubs) = s
               ELSEIF ctrlID = %IDM_ComboLibrs THEN   
                  INCR numLibrs: librs(numLibrs) = s
               ELSEIF ctrlID = %IDM_ComboCatgs THEN   
                  INCR numCatgs: catgs(numCatgs) = s
               END IF
            ELSEIF nOpt = 2 THEN 'change drop down list item
               CONTROL GET TEXT CB.HNDL, %ID_DropDnCombo TO s
               COMBOBOX FIND EXACT CB.HNDL, %ID_DropDnCombo, 1, s TO n
               COMBOBOX GET USER CB.HNDL, %ID_DropDnCombo, n TO n
               CONTROL GET TEXT CB.HNDL, %ID_DropDnEdit TO s
               IF n <= 0 THEN
                  MSGBOX "Must select item to change from list", %MB_ICONERROR, ""
                  CONTROL SET FOCUS CB.HNDL, %ID_DropDnCombo: EXIT FUNCTION
               END IF
               IF ctrlID = %IDM_ComboAuthors THEN
                  authors(n) = s
               ELSEIF ctrlID = %IDM_ComboCallNos THEN    
                  callNos(n) = s
               ELSEIF ctrlID = %IDM_ComboPubs THEN   
                  pubs(n) = s
               ELSEIF ctrlID = %IDM_ComboLibrs THEN   
                  librs(n) = s
               ELSEIF ctrlID = %IDM_ComboCatgs THEN   
                  catgs(n) = s
               END IF 
            ELSEIF nOpt = 3 THEN 'remove drop down list item
               CONTROL GET TEXT CB.HNDL, %ID_DropDnCombo TO s
               'COMBOBOX FIND EXACT CB.HNDL, %ID_DropDnCombo, 1, s TO m 
               COMBOBOX GET SELECT CB.HNDL, %ID_DropDnCombo TO m
               COMBOBOX GET USER CB.HNDL, %ID_DropDnCombo, m TO n
               IF ctrlID = %IDM_ComboAuthors THEN
                  'first, replace author reference with a lower numbered duplicate, if there is one 
                  DIM dups(1 TO numAuthors) AS LONG
                  COMBOBOX FIND EXACT CB.HNDL, %ID_DropDnCombo, 1, s TO k
                  COMBOBOX GET USER CB.HNDL, %ID_DropDnCombo, k TO j
                  numDups = 1: dups(numDups) = j
                  WHILE k 'get duplicates
                     COMBOBOX FIND EXACT CB.HNDL, %ID_DropDnCombo, k + 1, s TO k
                     COMBOBOX GET USER CB.HNDL, %ID_DropDnCombo, k TO j
                     IF k THEN INCR numDups: dups(numDups) = j
                  WEND
                  k = dups(1) 'get the minimum duplicate
                  FOR i = 1 TO numDups: k = MIN(n, dups(i)): NEXT i
                  FOR i = 1 TO numBooks
                     IF books(i).author = n THEN books(i).author = k
                  NEXT i
                  
                  FOR i = 1 TO numBooks  'now, make sure this author is not in use     
                     IF books(i).author = n THEN
                        msg = "Cannot remove author... currently being used by a book"
                        MSGBOX msg, %MB_ICONWARNING, authors(n): EXIT FUNCTION
                     END IF
                  NEXT i
                  ARRAY DELETE authors(n): DECR numAuthors
                  'adjustBookPtrsMacro(books(i).author)
                  adjustBookPtrsMacro(books(n).author)
               ELSE
                  CONTROL GET TEXT CB.HNDL, %ID_DropDnCombo TO ss   
                  m = ctrlID - %IDM_ComboAuthors
                  s = CHOOSE$(m, "Call number", "Publication", "Library", "Category")
                  msg = "Ok to delete this " + s + " from all books?"
                  k = MSGBOX(msg, %MB_ICONQUESTION OR %MB_OKCANCEL, s + " - " + ss)
                  IF k = %IDOK THEN
                     IF ctrlID = %IDM_ComboCallNos THEN    
                        ARRAY DELETE callNos(n): DECR numCallNos
                        adjustBookPtrsMacro(books(n).callNo)
                     ELSEIF ctrlID = %IDM_ComboPubs THEN   
                        ARRAY DELETE pubs(n): DECR numPubs
                        adjustBookPtrsMacro(books(n).publisher)
                     ELSEIF ctrlID = %IDM_ComboLibrs THEN
                        ARRAY DELETE librs(n): DECR numLibrs
                        adjustBookPtrsMacro(books(n).library)
                     ELSEIF ctrlID = %IDM_ComboCatgs THEN   
                        ARRAY DELETE catgs(n): DECR numCatgs
                        adjustBookPtrsMacro(books(n).catg)
                     END IF
                  END IF
               END IF   
            END IF   
            listBooks  
            fileChanged = 1 
            DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
         END IF
   END SELECT   
END FUNCTION

FUNCTION processName(s AS STRING) AS STRING
   'Bob W. Smith      -->  Smith, Bob W.
   'Bob Wright Smith  -->  Smith, Bob Wright
   'bob smith         -->  Smith, Bob
   '---------------------------------------------------
   LOCAL i, n, k, start, comma AS LONG
   LOCAL ss, ch AS STRING
   IF LEN(s) = 0 THEN EXIT FUNCTION
   
   'first, get the names, skipping commas and spaces
   k = PARSECOUNT(s, ANY ", ")
   DIM names(1 TO k) AS STRING
   PARSE s, names(), ANY ", "
   IF INSTR(s, ",") THEN comma = 1
   FOR i = 1 TO k
      IF LEN(names(i)) THEN
         INCR n: names(n) = UCASE$(LEFT$(names(i), 1)) + MID$(names(i), 2)
      END IF
   NEXT i
   
   ss = ""
   IF n = 1 THEN 'single name author
      ss = names(1)
   ELSEIF comma THEN 'first name followed by comma
      FOR i = 2 TO n
         ss = ss + names(i) + " "
      NEXT i                                      
      ss = names(1) + ", " + TRIM$(ss)
   ELSE 'all names separated by spaces
      FOR i = 1 TO n - 1
         ss = ss + names(i) + " "
      NEXT i
      ss = names(n) + ", " + TRIM$(ss)
   END IF
    
   IF LEFT$(ss, 2) = "Mc" THEN MID$(ss, 3, 1) = UCASE$(MID$(ss, 3, 1)) 
   IF LEFT$(ss, 3) = "Mac" THEN MID$(ss, 4, 1) = UCASE$(MID$(ss, 4, 1))
   FUNCTION = ss
END FUNCTION

FUNCTION processTitle(s AS STRING) AS STRING
   LOCAL i, n AS LONG
   LOCAL lc, ss AS STRING
   lc = "the,an,a,on,of,to,for,with,as,by,in, so"
   n = PARSECOUNT(s, " ")
   DIM ti(1 TO n) AS STRING
   PARSE s, ti(), " "
   FOR i = 1 TO n
      IF INSTR(lc, ti(i)) = 0 OR i = 1 THEN
         ti(i) = UCASE$(LEFT$(ti(i), 1)) + MID$(ti(i), 2)
      END IF 
      ss = ss + ti(i) + " "
   NEXT i
   FUNCTION = TRIM$(ss)
END FUNCTION

FUNCTION compressDate(s AS STRING) AS WORD
   '4 bit month, 5 bit day, 7 bit year
   LOCAL mo, day, yr AS WORD, year AS STRING
   IF LEN(s) THEN
      mo = VAL(PARSE$(s, ANY "-/", 1))
      day = VAL(PARSE$(s, ANY "-/", 2))
      year = PARSE$(s, ANY "-/", 3)
      yr = VAL(year)
      IF LEN(year) <> 4 THEN yr = 2000 + yr
      yr = yr - 1980
      ROTATE RIGHT yr, 7
      ROTATE LEFT mo, 5
      FUNCTION = yr + mo + day
   END IF
END FUNCTION

FUNCTION expandDate(w AS WORD) AS STRING
   LOCAL mo, day, yr AS WORD
   LOCAL m, d AS STRING
   day = w AND 31
   mo = w AND 480
   yr = w AND 65024
   ROTATE LEFT yr,7
   ROTATE RIGHT mo,5
   m = RIGHT$("0" + LTRIM$(STR$(mo)), 2)
   d = RIGHT$("0" + LTRIM$(STR$(day)), 2)
   FUNCTION = m + "-" + d + "-" + LTRIM$(STR$(yr + 1980))
END FUNCTION

FUNCTION KeyboardHook(BYVAL iCode AS INTEGER, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS DWORD
   LOCAL s AS STRING, n AS LONG, i AS LONG, j AS LONG
   STATIC nCount AS LONG
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParam, lParam)
      EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR nCount: IF nCount MOD 2 = 0 THEN nCount = 0: EXIT FUNCTION
   SELECT CASE wParam
   CASE %VK_BACK, %VK_DELETE
      IF editAuthor THEN
         CONTROL GET TEXT hAddBook, %ID_Author TO s
         CONTROL SEND hAddBook, %ID_Author, %CB_GETEDITSEL, 0, 0 TO n
         i = LOWRD(n): j = HIWRD(n)
         IF i <> j THEN
            s = LEFT$(s, i) + MID$(s, j + 1)
            CONTROL SET TEXT hAddBook, %ID_Author, s
            n = -1: SHIFT LEFT n, 16: n = n + LEN(s)
            CONTROL SEND hAddBook, %ID_Author, %CB_SETEDITSEL, 0, n
         END IF
      END IF
   CASE %VK_RETURN
      IF srchAuthorTi THEN
         CONTROL SET FOCUS hTab, listID 
      ELSEIF GetDlgCtrlID(GetFocus) = listID THEN
         DIALOG SEND hMain, %WM_COMMAND, %ID_ViewBtn, 0
      END IF
   END SELECT
END FUNCTION
                                                                
SUB initializeBooks()
   LOCAL s AS STRING
   IF numCallNos = 0 THEN
      numCallNos = 11: REDIM callNos(1 TO numCallNos)
      s = "Fic, Mys, SF, YA, PB, New, W, ROM, ADV, LT, NonFic"
      PARSE s, callNos() 
   END IF
   IF numCatgs = 0 THEN
      numCatgs = 33: REDIM catgs(1 TO numCatgs)
      s = "Detective/PI, Suspense, Police Procedural, Adventure, Special Ops, Detectives as Chefs, " + _
          "Corporate World, Espionage, Romance, Historical Fiction, Contemporary, Southwest Mysteries, " + _
          "British Mysteries, War, Family Sagas, Victorian Novels, Fantacy, Vampires, Americal Revolution, " + _
          "Civil War, Naval, Norman England, Scotland, Disasters, Survival, Legal Mysteries, " + _
          "Medical Mysteries, Humor, Cats, Dogs, Horses, Wolves, American History"
      PARSE s, catgs()    
   END IF
END SUB

FUNCTION insertBookNo(sAuthor AS STRING, sTitle AS STRING) AS LONG
   'return insert position of book in bookNo()
   'use alphabetical order of author + title (exclude leading articles in title)
   LOCAL i, j AS LONG
   LOCAL s, si AS STRING
   IF LEN(sAuthor) = 0 THEN sAuthor = " "
   s = sTitle: s = LTRIM$(s, "The "): s = LTRIM$(s, "A "): s = LTRIM$(s, "An ")
   s = LCASE$(sAuthor + " " + TRIM$(s))
   DO  
      INCR i: IF i < numBooks THEN j = bookNo(i) ELSE EXIT DO
      si = titles(j):
      si = LTRIM$(si, "The "): si = LTRIM$(si, "A "): si = LTRIM$(si, "An ")
      si = LCASE$(authors(books(j).author) + " " + TRIM$(si))
   LOOP WHILE si <= s AND i < numBooks
   FUNCTION = i 
END FUNCTION

SUB showStatus()
   LOCAL n, i, j AS LONG, s AS STRING
   n = INSTR(-1, thisFile, "\")
   s = "Filename: " + MID$(thisFile, n + 1)
   STATUSBAR SET TEXT hMain, %ID_Status, 1, 0, s
   STATUSBAR SET TEXT hMain, %ID_Status, 2, 0, ""
   STATUSBAR SET TEXT hMain, %ID_Status, 3, 0, ""
   IF numToShow THEN   
      s = " Category: "
      i = oColList.getHiLite
      IF i THEN j = oColList.getExtra(i)
      IF j THEN
         n = books(j).catg
         IF n THEN s = s + catgs(n)
         STATUSBAR SET TEXT hMain, %ID_Status, 2, 0, s
      END IF
      IF j THEN s = STR$(i) + " :" + STR$(numToShow) ELSE s = ""
      STATUSBAR SET TEXT hMain, %ID_Status, 3, 0, s
   END IF
END SUB

SUB searchAuthorTi()
   'this routine searches the database for either a specified author or title
   'it will automatically search for the next match and loop around when done
   'red label will display if not found
   '-----------------------------------------------------------------------------
   LOCAL i, j, m AS LONG
   LOCAL s, ss, txt AS STRING
   STATIC start AS LONG 
   CONTROL GET TEXT hMain, %ID_AuthorTi TO s
   IF LEN(s) = 0 THEN start = 0
   IF s = "Author/Title" THEN EXIT SUB
   CONTROL SET TEXT hMain, %ID_NotFound, ""
   txt = s: s = LCASE$(s)   
   IF LEN(s) THEN
      FOR i = start + 1 TO numToShow 'search for author
         j = oColList.getExtra(i) 
         m = books(j).author: ss = LCASE$(authors(m))
         IF INSTR(ss, s) THEN oColList.setHiLite(i): showStatus: start = i: EXIT SUB 
      NEXT i
      FOR i = start + 1 TO numToShow 'search for title
         j = oColList.getExtra(i): ss = LCASE$(titles(j))
         IF INSTR(ss, s) THEN oColList.setHiLite(i): showStatus: start = i: EXIT SUB
      NEXT i
      start = 0
      CONTROL SET TEXT hMain, %ID_NotFound, "Not found"
      CONTROL SET TEXT hMain, %ID_AuthorTi, txt
      CONTROL SEND hMain, %ID_AuthorTi, %EM_SETSEL, LEN(txt), LEN(txt)
   END IF
END SUB

SUB whichBooks()
   'determine which books to show based on tabPage
   LOCAL i, j AS LONG
   numToShow = 0 
   FOR j = 1 TO numBooks
      i = bookNo(j)
      BIT RESET books(i).flags, 5
      IF BIT(books(i).flags, 4) THEN ITERATE
      IF tabPage = 1 THEN
         BIT SET books(i).flags, 5   
      ELSEIF tabPage > 1 AND tabPage < 4 THEN
         IF BIT(books(i).flags, tabPage - 1) THEN BIT SET books(i).flags, 5
      ELSEIF tabPage = 4 THEN
         IF BIT(books(i).flags, 3) THEN BIT SET books(i).flags, 5   
      END IF
      IF BIT(books(i).flags, 5) THEN INCR numToShow
   NEXT j 
END SUB

SUB listBooks(OPT BYVAL index AS LONG, BYVAL top AS LONG)
   LOCAL i, j, k, m, n, nShow AS LONG
   LOCAL s, sAuthor, sCallNo, sOrdered, sPubDate, sLibr AS STRING
   whichBooks
   oColList.SetNumItems = 0
   FOR j = 1 TO numBooks
      i = bookNo(j)
      IF BIT(books(i).flags, 5) THEN 'to be shown
         m = books(i).author:
         sAuthor = authors(m)
         IF sAuthor = ", " THEN sAuthor = ""
         sCallNo = "": sOrdered = "": sPubDate = "": sLibr = ""
         n = books(i).callNo: IF n THEN sCallNo = callNos(n)
         n = books(i).ordered: IF n THEN sOrdered = expandDate(CWRD(n)) + " "
         n = books(i).pubDate: IF n THEN sPubDate = TRIM$(STR$(n))
         n = books(i).library: IF n THEN sLibr = librs(n)
         s = sAuthor + $TAB + titles(i) + $TAB + sCallNo + $TAB + sPubDate + $TAB + sOrdered + $TAB + sLibr
         oColList.addItem(s, i): INCR nShow
         IF j = index THEN k = nShow
      END IF
   NEXT j
   oColList.showList
   oColList.setHiLite(-MAX(k, 1), top)
   showStatus 
END SUB

SUB saveIniFile()
   LOCAL hFile AS LONG
   hFile = FREEFILE
   OPEN iniFile FOR OUTPUT AS hFile
   PRINT# hFile, thisFile
   CLOSE hFile
END SUB

SUB openIniFile()
   LOCAL hFile AS LONG
   hFile = FREEFILE
   OPEN iniFile FOR INPUT AS hFile
   INPUT# hFile, thisFile
   CLOSE hFile
END SUB

SUB openThisFile()
   LOCAL hFile, i, j, k, yr AS LONG
   LOCAL s, ver AS STRING
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS hFile
   ver = SPACE$(18)
   GET hFile,, ver
   GET hFile,, numBooks
   GET hFile,, numAuthors
   GET hFile,, numCallNos
   GET hFile,, numPubs
   GET hFile,, numLibrs
   GET hFile,, futureUse
   GET hFile,, numCatgs

   REDIM bookNo(1 TO numBooks)
   REDIM books(1 TO numBooks)
   REDIM titles(1 TO numBooks)
   REDIM comments(1 TO numBooks)
   REDIM authors(1 TO numAuthors)
   REDIM callNos(1 TO numCallNos)
   REDIM pubs(1 TO numPubs)
   REDIM librs(1 TO numLibrs)
   REDIM catgs(1 TO numCatgs)
   IF numBooks THEN
      GET hFile,, bookNo()
      GET hFile,, books()
      GET hFile,, titles()
      GET hFile,, comments()
   END IF
   IF numAuthors THEN GET hFile,, authors()
   IF numCallNos THEN GET hFile,, callNos()
   IF numPubs THEN GET hFile,, pubs()
   IF numLibrs THEN GET hFile,, librs()
   IF numCatgs THEN GET hFile,, catgs() 
   CLOSE hFile
   
   'we decided to consider all archived read books as just read
   'we decided to limit pubDate to just year rather than mo-yr
   FOR i = 1 TO numBooks
      IF BIT(books(i).flags, 3) THEN
         BIT SET books(i).flags, 2
         BIT RESET books(i).flags, 3
      END IF
      k = books(i).pubDate
      IF k > 2500 THEN
         books(i).pubDate = k \ 16
      END IF
   NEXT i
   
'   'eliminate duplicate authors
'   DIM tempAuthors(1 TO numAuthors) AS STRING
'   LOCAL found AS LONG
'   FOR i = 1 TO numBooks 
'      k = books(i).author
'      s = authors(k)
'      IF LEN(tempAuthors(k)) = 0 THEN
'         found = 0
'         FOR j = 1 TO numAuthors
'            IF s = tempAuthors(j) THEN found = j: EXIT FOR
'         NEXT j
'         IF found THEN books(i).author = j ELSE tempAuthors(k) = s
'      END IF   
'   NEXT i
      
   
'   IF numLibrs > 10 THEN 'correct carolTest.lib
'      numLibrs = 2
'      REDIM librs(1 TO numLibrs)
'      librs(1) = "Indian Valley"
'      librs(2) = "Doylestown"
'      FOR i = 1 TO numBooks
'         IF books(i).library = 4 THEN
'            books(i).library = 2
'         ELSEIF books(i).library THEN
'            books(i).library = 1
'         END IF   
'      NEXT i
'   END IF

   tabPage = 1: oColList = oColList1
   IF numBooks THEN listBooks
   hTab = tabHandle(1): listID = %ID_All: tabPage = 1
   SetFocus GetDlgItem(hMain, %ID_Tab): fileChanged = 0
END SUB

SUB saveThisFile()
   LOCAL hFile, i, j, k, n, removeBooks AS LONG
   LOCAL ver AS STRING * 18

   'test deleting books   
   'i = 1: j = bookNo(i): BIT SET books(j).flags, 4
   'i = 2: j = bookNo(i): BIT SET books(j).flags, 4
   'i = 12: j = bookNo(i): BIT SET books(j).flags, 4
   'i = 33: j = bookNo(i): BIT SET books(j).flags, 4
   'i = 34: j = bookNo(i): BIT SET books(j).flags, 4

   'first, delete books marked for removal
   n = numBooks: i = 0
   DO
      INCR i: k = bookNo(i)
      IF BIT(books(k).flags, 4) THEN 'marked for removal
         removeBooks = 1
         ARRAY DELETE bookNo(i): DECR n
         FOR j = 1 TO n
            IF bookNo(j) > k THEN DECR bookNo(j)
         NEXT j
         ARRAY DELETE books(k)
         ARRAY DELETE titles(k)
         ARRAY DELETE comments(k)
         DECR i
      END IF
   LOOP UNTIL i = n
   numBooks = n
   
   IF LEN(thisFile) = 0 THEN saveAsFile
   ver = "LibrList Version 1"
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS hFile
   PUT hFile,, ver
   PUT hFile,, numBooks
   PUT hFile,, numAuthors
   PUT hFile,, numCallNos
   PUT hFile,, numPubs
   PUT hFile,, numLibrs
   PUT hFile,, futureUse
   PUT hFile,, numCatgs
   
   IF numBooks THEN
      REDIM PRESERVE bookNo(1 TO numBooks)
      REDIM PRESERVE books(1 TO numBooks)
      REDIM PRESERVE titles(1 TO numBooks)
      REDIM PRESERVE comments(1 TO numBooks)
      PUT hFile,, bookNo()
      PUT hFile,, books()
      PUT hFile,, titles()
      PUT hFile,, comments()
   END IF
   IF numAuthors THEN REDIM PRESERVE authors(1 TO numAuthors): PUT hFile,, authors()
   IF numCallNos THEN REDIM PRESERVE callNos(1 TO numCallNos): PUT hFile,, callNos()
   IF numPubs THEN REDIM PRESERVE pubs(1 TO numPubs): PUT hFile,, pubs()
   IF numLibrs THEN REDIM PRESERVE librs(1 TO numLibrs): PUT hFile,, librs()
   IF numCatgs THEN REDIM PRESERVE catgs(1 TO numCatgs): PUT hFile,, catgs()
   
   CLOSE hFile: fileChanged = 0
   saveIniFile
END SUB

SUB saveAsFile()
   LOCAL flags AS LONG
   LOCAL f, ti, folder, filter AS STRING
   ti = "Save File": folder = dataFolder  'CURDIR$
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("Libr List", 0, "*.lib", 0, "All Files", 0, "*.*", 0)
   DISPLAY SAVEFILE hMain,,, ti, folder, filter, "", "bus", flags TO f
   IF LEN(f) THEN thisFile = f: saveThisFile
END SUB
 
SUB createFolder(folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s AS STRING
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN 
         s = s + f + "\"
         IF ISFILE(s) = 0 THEN MKDIR s
      END IF 
   NEXT i
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

SUB printBook(index AS LONG)
   'print all data for this single book
   LOCAL i, k, m, n AS LONG
   LOCAL s, ss, sPrinter AS STRING
   LOCAL x, y, dy, charWi, charHt AS DOUBLE
   LOCAL oTPrint AS iTPrint
   LET oTPrint = CLASS "cTPrint"
   DIM s1(8) AS STRING
   DIM s2(8) AS STRING
   
   sPrinter = oTPrint.choosePrinter
   IF LEN(sPrinter) = 0 THEN EXIT SUB
   oTPrint.newFont "MS Sans Serif", 10, ""
   oTPrint.setMargins .75, .50, .50, .50
   oTPrint.getCharSize(charWi, charHt)
   x = .75: y = 1.00: dy = 1.20 * charHt
   k = oColList.getExtra(index)
   
   IF BIT(books(k).flags, 1) THEN 
      s = "Book source - Want to read"
   ELSE
      s = "Book source - Have read"
   END IF
   
   
   s1(1) = "Author:"          : s2(1) = authors(books(k).author)
   s1(2) = "Title:"           : s2(2) = titles(k)
   s1(3) = "Call Number:"     : n = books(k).callNo: IF n THEN s2(3) = callNos(n) 
   s1(4) = "Publisher:"       : n = books(k).publisher: IF n THEN s2(4) = pubs(n)
   s1(5) = "Order date:"      : n = books(k).Ordered: IF n THEN s2(5) = expandDate(CWRD(n))
   s1(6) = "Publish date:"    : n = books(k).PubDate: IF n THEN s2(6) = TRIM$(STR$(n))
   s1(7) = "Library:"         : n = books(k).library: IF n THEN s2(7) = librs(n)
   s1(8) = "Category:"        : n = books(k).catg: IF n THEN s2(8) = catgs(n)

   oTPrint.beginDoc "LibrList"
   oTPrint.beginPage
   
   oTPrint.printText s, x, y: y = y + 3 * dy
   FOR i = 1 TO 8
      oTPrint.printText s1(i), x, y 
      oTPrint.printText s2(i), x + 2, y: y = y + dy  
   NEXT i
   
   'now, print the Source/comments
   oTPrint.printText "Source/comments:", x, y: s = comments(k)
   WHILE LEN(s)
      ss = oTPrint.truncate(s, 4.5): n = LEN(ss)
      m = INSTR(-1, ss, ANY " ,;.-_")
      IF m THEN n = m: ss = LEFT$(ss, n)
      m = INSTR(ss, $CRLF)
      IF m THEN n = m: ss = LEFT$(s, m - 1)
      IF m THEN s = MID$(s, n + 2) ELSE s = MID$(s, n + 1)
      oTPrint.printText ss, x + 2, y: y = y + dy 
   WEND
   
   oTPrint.closePage
   oTPrint.closeDoc
END SUB

SUB printBooks()
   'print all books in tab
   LOCAL i, ii, j, xppi, yppi, nextPage, nextColumn, columnNo AS LONG 
   LOCAL maxLines, hFont, hdc, nFit, xDuplex, nPage AS LONG, m AS WORD
   LOCAL x0, x1, x, y, charWi, charHt, pageHt, pageWi, allowLen, u AS DOUBLE
   LOCAL s, ti, sAuthor, sTitle, sPrinter AS STRING, sz AS ASCIIZ*256
   LOCAL cSize AS SIZEL
   LOCAL oTPrint AS iTPrint
   LET oTPrint = CLASS "cTPrint"
   DIM tabTitles(5) AS STRING
   tabTitles(1) = "All books"
   tabTitles(2) = "Books to read"
   tabTitles(3) = "Current books read"
   tabTitles(4) = "Archived books read"
   tabTitles(5) = "Custom list"
   ti = tabTitles(tabPage)
   sPrinter = oTPrint.choosePrinter
   IF LEN(sPrinter) = 0 THEN EXIT SUB
   hdc = oTPrint.hdc
    
   oTPrint.newFont "MS Sans Serif", 9, ""
   oTPrint.setMargins .75, .50, .50, .50
   maxLines = oTPrint.getLines() - 7
   oTPrint.getCharSize(charWi, charHt)
   pageWi = 8.5
   pageHt = 11.0
   x0 = 0.75
   x1 = 4.50
   allowLen = 3.25
   'maxLines = 20 '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> for testing only
   nextPage = 1: nextColumn = 1
   oTPrint.beginDoc "LibrList"
   FOR i = 1 TO numBooks
      IF nextColumn THEN
         IF nextPage THEN 'print top header
            INCR nPage: y = .50
            oTPrint.beginPage
            oTPrint.printText ti, x0, y
            oTPrint.printText STR$(nPage), pageWi/2, pageHt-0.50-2*charHt
            nextPage = 0: columnNo = 1
         END IF
         ii = 1: nextColumn = 0
         IF columnNo MOD 2 THEN x = x0 ELSE x = x1: columnNo = 2
      END IF
      IF BIT(books(bookNo(i)).flags, 5) THEN 'print displayed books  
         INCR ii: j = bookNo(i)
         sAuthor = authors(books(j).author)
         sTitle = titles(j)
         IF TRIM$(sAuthor) = "," THEN sAuthor = ""
         s = sAuthor + " - " + sTitle
         s = oTPrint.truncate(s, allowLen)
         oTPrint.printText s, x, y + ii*charHt
         IF tabPage = 2 THEN 'more to print
            m = books(j).callNo
            IF m THEN oTPrint.printText callNos(m), 4.25, y + ii*charHt
            m = books(j).pubDate
            IF m THEN oTPrint.printText TRIM$(STR$(m)), 5.00, y + ii*charHt
            m = books(j).ordered
            IF m THEN oTPrint.printText expandDate(m), 5.50, y + ii*charHt
            m = books(j).library
            IF m THEN
               s = oTPrint.truncate(librs(m), 1.50)
               oTPrint.printText s, 6.50, y + ii*charHt
            END IF 
         END IF
         IF ii <= numBooks AND ii = maxLines + 3 THEN 'print 2nd column
            nextColumn = 1: INCR columnNo
            IF tabPage = 2 OR columnNo > 2 THEN nextPage = 1: oTPrint.closePage
         END IF
      END IF
   NEXT i
   oTPrint.closePage
   oTPrint.closeDoc
END SUB

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
SUB showAbout  
   LOCAL hAbout AS LONG, s AS STRING 
   DIALOG NEW hMain,"About My Library List",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "My Library List", 50, 10, 80, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 130, 13, 70, 10
   s = "Version " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 40, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "LibrList", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL showAboutProc 
END SUB
 
CALLBACK FUNCTION showAboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CB.MSG
   CASE %WM_PAINT
      FONT NEW "MS Sans Serif", 14 TO hFont
      CONTROL SET COLOR CB.HNDL, 9901, %RED, -1
      CONTROL SET FONT CB.HNDL, 9901, hFont
      FONT NEW "MS Sans Serif", 10, 2 TO hFont
      CONTROL SET FONT CB.HNDL, 9902, hFont
      FONT NEW "MS Sans Serif", 10 TO hFont
      CONTROL SET FONT CB.HNDL, 9903, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9904, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9904, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9905, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9905, hFont
      FONT END hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CB.HNDL, %DWL_MSGRESULT, 1: FUNCTION = 1 
      END IF 
   CASE %WM_COMMAND 
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN 
         DIALOG END CB.HNDL
      ELSEIF CB.CTL = 9904 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)   
      ELSEIF CB.CTL = 9905 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
      
   END SELECT
END FUNCTION 
 